searchData={"items":[{"type":"module","title":"Appendix","doc":"Documentation for `Appendix`.","ref":"Appendix.html"},{"type":"function","title":"Appendix.hello/0","doc":"Hello world.","ref":"Appendix.html#hello/0"},{"type":"function","title":"Examples - Appendix.hello/0","doc":"iex> Appendix.hello()\n    :world","ref":"Appendix.html#hello/0-examples"},{"type":"module","title":"Appendix.Jsonb","doc":"A module for building Ecto queries with JSONB columns.\n\nThis module provides a macro `json_query/4` to generate dynamic where clauses\nfor JSONB columns in an Ecto query.","ref":"Appendix.Jsonb.html"},{"type":"macro","title":"Appendix.Jsonb.json_query/4","doc":"Builds a dynamic where clause for JSONB columns in an Ecto query.","ref":"Appendix.Jsonb.html#json_query/4"},{"type":"macro","title":"Parameters - Appendix.Jsonb.json_query/4","doc":"- qry: The initial query.\n  - col: The JSONB column to query.\n  - params: A keyword list of key-value pairs to match against the JSONB column.\n  - opts: A keyword list of options. Supports `:where_type`, which can be `:where` or `:or_where`. Defaults to `:where`.","ref":"Appendix.Jsonb.html#json_query/4-parameters"},{"type":"macro","title":"Examples - Appendix.Jsonb.json_query/4","doc":"iex> import Ecto.Query\n    iex> query = from(p in Post)\n    iex> json_query(query, :metadata, [title: \"Elixir\", author: \"José\"], where_type: :where)\n    # Ecto query with JSONB where clauses","ref":"Appendix.Jsonb.html#json_query/4-examples"},{"type":"module","title":"Appendix.Namespace","doc":"A module for defining namespaced routes in Plug applications. This module provides\nmacros for organizing routes under a common path, similar to Phoenix's pipelines\nbut scoped to a specific route.","ref":"Appendix.Namespace.html"},{"type":"macro","title":"Appendix.Namespace.namespace/2","doc":"Defines a namespace for a group of routes under the given path. The `namespace`\nmacro allows you to group related routes and apply common plugs to all routes\nwithin the namespace.","ref":"Appendix.Namespace.html#namespace/2"},{"type":"macro","title":"Parameters - Appendix.Namespace.namespace/2","doc":"- `path`: The base path for the namespace (e.g., `\"/api\"`).\n  - `do: block`: The block of code containing the routes and plugs to be applied\n    within the namespace.","ref":"Appendix.Namespace.html#namespace/2-parameters"},{"type":"macro","title":"Example - Appendix.Namespace.namespace/2","doc":"namespace \"/api\" do\n      plug Plug.Logger\n\n      get \"/status\" do\n        send_resp(conn, 200, \"API is up and running\")\n      end\n    end","ref":"Appendix.Namespace.html#namespace/2-example"},{"type":"module","title":"Appendix.Response","doc":"A module providing wrappers for common HTTP responses in Plug applications.\n\nThis module includes functions to send JSON, HTML, text, file responses, and more.\nIt also provides utilities for handling Ecto changeset errors and redirecting requests.","ref":"Appendix.Response.html"},{"type":"macro","title":"Appendix.Response.__using__/1","doc":"Sets up common imports for modules using `Responses`.\n\nThis macro imports `Plug.Conn` and the current module for easy access to response helpers.","ref":"Appendix.Response.html#__using__/1"},{"type":"macro","title":"Examples - Appendix.Response.__using__/1","doc":"defmodule MyRouter do\n      use Plug.Router\n      use Responses\n\n      plug :match\n      plug :dispatch\n\n      get \"/\" do\n        conn |> json(:ok, %{hello: \"world\"})\n      end\n    end","ref":"Appendix.Response.html#__using__/1-examples"},{"type":"function","title":"Appendix.Response.changeset_params/1","doc":"Converts string keys in params to atoms.","ref":"Appendix.Response.html#changeset_params/1"},{"type":"function","title":"Parameters - Appendix.Response.changeset_params/1","doc":"- params: A map with string keys.","ref":"Appendix.Response.html#changeset_params/1-parameters"},{"type":"function","title":"Examples - Appendix.Response.changeset_params/1","doc":"changeset_params(%{\"name\" => \"John\"})\n    # => %{name: \"John\"}","ref":"Appendix.Response.html#changeset_params/1-examples"},{"type":"function","title":"Appendix.Response.download/3","doc":"Sends a file download response.","ref":"Appendix.Response.html#download/3"},{"type":"function","title":"Parameters - Appendix.Response.download/3","doc":"- conn: HTTP connection to send the response to.\n  - path: File path for the file response.\n  - opts: Keyword list of options. Supports `:resp_headers` to add response headers.","ref":"Appendix.Response.html#download/3-parameters"},{"type":"function","title":"Examples - Appendix.Response.download/3","doc":"conn |> download(:ok, \"/path/to/file\")\n    conn |> download(:ok, \"/path/to/file\", resp_headers: %{\"x-foo\" => \"bar\"})","ref":"Appendix.Response.html#download/3-examples"},{"type":"function","title":"Appendix.Response.file/3","doc":"Sends a file response.","ref":"Appendix.Response.html#file/3"},{"type":"function","title":"Parameters - Appendix.Response.file/3","doc":"- conn: HTTP connection to send the response to.\n  - path: File path for the file response.\n  - opts: Keyword list of options. Supports `:resp_headers` to add response headers.","ref":"Appendix.Response.html#file/3-parameters"},{"type":"function","title":"Examples - Appendix.Response.file/3","doc":"conn |> file(:ok, \"/path/to/file\")\n    conn |> file(:ok, \"/path/to/file\", resp_headers: %{\"x-foo\" => \"bar\"})","ref":"Appendix.Response.html#file/3-examples"},{"type":"function","title":"Appendix.Response.html/4","doc":"Sends an HTML response.","ref":"Appendix.Response.html#html/4"},{"type":"function","title":"Parameters - Appendix.Response.html/4","doc":"- conn: HTTP connection to send the response to.\n  - status: Atom or number that represents the HTTP response code.\n  - data: HTML string set as the response body.\n  - opts: Keyword list of options. Supports `:resp_headers` to add response headers.","ref":"Appendix.Response.html#html/4-parameters"},{"type":"function","title":"Examples - Appendix.Response.html/4","doc":"conn |> html(:ok, \" Hello World \")\n    conn |> html(:ok, \" Hello World \", resp_headers: %{\"x-foo\" => \"bar\"})","ref":"Appendix.Response.html#html/4-examples"},{"type":"function","title":"Appendix.Response.json/4","doc":"Sends a JSON response.","ref":"Appendix.Response.html#json/4"},{"type":"function","title":"Parameters - Appendix.Response.json/4","doc":"- conn: HTTP connection to send the response to.\n  - status: Atom or number that represents the HTTP response code.\n  - data: Struct to be encoded to JSON as the response body.\n  - opts: Keyword list of options. Supports `:resp_headers` to add response headers.","ref":"Appendix.Response.html#json/4-parameters"},{"type":"function","title":"Examples - Appendix.Response.json/4","doc":"conn |> json(:ok, %{hello: \"World\"})\n    conn |> json(:ok, %{hello: \"World\"}, resp_headers: %{\"x-foo\" => \"bar\"})","ref":"Appendix.Response.html#json/4-examples"},{"type":"function","title":"Appendix.Response.parse_errors/1","doc":"Parses errors from an Ecto changeset or a given error map/string.","ref":"Appendix.Response.html#parse_errors/1"},{"type":"function","title":"Parameters - Appendix.Response.parse_errors/1","doc":"- changeset: An Ecto changeset.\n  - errors: An error map or string.","ref":"Appendix.Response.html#parse_errors/1-parameters"},{"type":"function","title":"Examples - Appendix.Response.parse_errors/1","doc":"parse_errors(%Ecto.Changeset{errors: [name: {\"can't be blank\", []}]})\n    # => %{name: \"can't be blank\"}\n\n    parse_errors(\"An error occurred\")\n    # => %{error: \"An error occurred\"}","ref":"Appendix.Response.html#parse_errors/1-examples"},{"type":"function","title":"Appendix.Response.redirect/3","doc":"Redirects the request.","ref":"Appendix.Response.html#redirect/3"},{"type":"function","title":"Parameters - Appendix.Response.redirect/3","doc":"- conn: HTTP connection to redirect.\n  - status: Atom or number that represents the HTTP response code.\n  - url: String representing the URL/URI destination.","ref":"Appendix.Response.html#redirect/3-parameters"},{"type":"function","title":"Examples - Appendix.Response.redirect/3","doc":"conn |> redirect(\"http://example.com/\")\n    conn |> redirect(301, \"http://example.com/\")","ref":"Appendix.Response.html#redirect/3-examples"},{"type":"function","title":"Appendix.Response.status/3","doc":"Sends a status-only response.","ref":"Appendix.Response.html#status/3"},{"type":"function","title":"Parameters - Appendix.Response.status/3","doc":"- conn: HTTP connection to send the response to.\n  - status: Atom or number that represents the HTTP response code.\n  - opts: Keyword list of options. Supports `:resp_headers` to add response headers.","ref":"Appendix.Response.html#status/3-parameters"},{"type":"function","title":"Example - Appendix.Response.status/3","doc":"conn |> status(:ok)","ref":"Appendix.Response.html#status/3-example"},{"type":"function","title":"Appendix.Response.text/4","doc":"Sends a text response.","ref":"Appendix.Response.html#text/4"},{"type":"function","title":"Parameters - Appendix.Response.text/4","doc":"- conn: HTTP connection to send the response to.\n  - status: Atom or number that represents the HTTP response code.\n  - data: Text string set as the response body.\n  - opts: Keyword list of options. Supports `:resp_headers` to add response headers.","ref":"Appendix.Response.html#text/4-parameters"},{"type":"function","title":"Examples - Appendix.Response.text/4","doc":"conn |> text(:ok, \"Hello World!\")\n    conn |> text(:ok, \"Hello World!\", resp_headers: %{\"x-foo\" => \"bar\"})","ref":"Appendix.Response.html#text/4-examples"},{"type":"module","title":"Appendix.Router","doc":"A module for defining common Plug router configurations.\n\nThis module provides a macro `__using__/1` to include common router settings,\nsuch as required imports, plugs, and necessary configurations for handling requests.","ref":"Appendix.Router.html"},{"type":"macro","title":"Appendix.Router.__using__/1","doc":"A macro to set up common configurations for Plug routers.\n\nThis macro includes required imports, setups for parsers, and uses necessary modules\nlike `Plug.Router` and `Responses`.","ref":"Appendix.Router.html#__using__/1"},{"type":"macro","title":"Examples - Appendix.Router.__using__/1","doc":"defmodule MyRouter do\n      use Router\n\n      plug :match\n      plug :dispatch\n\n      get \"/\" do\n        send_resp(conn, 200, \"Welcome\")\n      end\n\n      match _ do\n        send_resp(conn, 404, \"Not Found\")\n      end\n    end","ref":"Appendix.Router.html#__using__/1-examples"},{"type":"module","title":"Appendix.Schema","doc":"A module for defining common Ecto schema configurations.\n\nThis module provides a macro `__using__/1` to include common schema settings,\nsuch as primary key type, foreign key type, and necessary imports.","ref":"Appendix.Schema.html"},{"type":"macro","title":"Appendix.Schema.__using__/1","doc":"A macro to set up common configurations for Ecto schemas.\n\nThis macro sets the primary key to use binary IDs, imports necessary Ecto modules,\nand sets the default foreign key type to binary ID.","ref":"Appendix.Schema.html#__using__/1"},{"type":"macro","title":"Examples - Appendix.Schema.__using__/1","doc":"defmodule MySchema do\n      use Schema\n\n      schema \"my_table\" do\n        field :name, :string\n        # additional fields\n      end\n\n      def changeset(struct, params \\ %{}) do\n        struct\n        |> cast(params, [:name])\n        |> validate_required([:name])\n      end\n    end","ref":"Appendix.Schema.html#__using__/1-examples"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}